geo_abstract_base_rep< T >abstract

abstract base interface class More...

Inheritance diagram for geo_abstract_base_rep< T >:

## Public Types

enum | geo_rep_variant_type { geo = 0 , geo_domain = 1 , geo_domain_indirect = 2 , max_variant = 3 }
typedef geo_element_hack::size_type | size_type
typedef point_basic< T > | node_type
typedef reference_element::variant_type | variant_type
typedef geo_element & | reference
typedef const geo_element & | const_reference
typedef space_constant::coordinate_type | coordinate_type
typedef std::map< size_type, geo_element_auto<> > | geo_element_map_type
typedef hack_array< geo_element_hack >::iterator | iterator_by_variant
typedef geo_iterator< geo_element, geo_element &, geo_element *, iterator_by_variant > | iterator
typedef hack_array< geo_element_hack >::const_iterator | const_iterator_by_variant
typedef geo_iterator< geo_element, const geo_element &, const geo_element *, const_iterator_by_variant > | const_iterator

## Public Member Functions

| geo_abstract_base_rep ()
virtual | ~geo_abstract_base_rep ()
virtual size_type | variant () const =0
virtual std::string | name () const =0
virtual std::string | familyname () const =0
virtual size_type | dimension () const =0
virtual size_type | serial_number () const =0
virtual size_type | map_dimension () const =0
virtual bool | is_broken () const =0
virtual coordinate_type | coordinate_system () const =0
virtual const basis_basic< T > & | get_piola_basis () const =0
virtual const node_type & | xmin () const =0
virtual const node_type & | xmax () const =0
virtual const T & | hmin () const =0
virtual const T & | hmax () const =0
virtual const geo_size & | sizes () const =0
virtual const geo_size & | ios_sizes () const =0
virtual const distributor & | geo_element_ownership (size_type dim) const =0
virtual const_reference | get_geo_element (size_type dim, size_type ige) const =0
virtual const geo_element & | bgd2dom_geo_element (const geo_element &bgd_K) const
virtual const geo_element & | dom2bgd_geo_element (const geo_element &dom_K) const
virtual size_type | neighbour (size_type ie, size_type loc_isid) const =0
virtual void | neighbour_guard () const =0
virtual const_iterator_by_variant | begin_by_variant (variant_type variant) const =0
virtual const_iterator_by_variant | end_by_variant (variant_type variant) const =0
virtual const geo_element_map_type & | get_external_geo_element_map (size_type variant) const =0
const_iterator | begin (size_type dim) const
const_iterator | end (size_type dim) const
virtual size_type | n_node () const =0
virtual const node_type & | node (size_type inod) const =0
virtual const node_type & | dis_node (size_type dis_inod) const =0
virtual void | dis_inod (const geo_element &K, std::vector< size_type > &dis_inod) const =0
virtual size_type | dis_inod2dis_iv (size_type dis_inod) const =0
virtual size_type | n_domain_indirect () const =0
virtual bool | have_domain_indirect (const std::string &name) const =0
virtual void | reset_order (size_type order)=0
virtual size_type | seq_locate (const point_basic< T > &x, size_type dis_ie_guest=std::numeric_limits< size_type >::max()) const =0
virtual size_type | dis_locate (const point_basic< T > &x, size_type dis_ie_guest=std::numeric_limits< size_type >::max()) const =0
virtual size_type | seq_trace_move (const point_basic< T > &x, const point_basic< T > &v, point_basic< T > &y) const =0
virtual size_type | dis_trace_move (const point_basic< T > &x, const point_basic< T > &v, point_basic< T > &y) const =0
virtual size_type | seq_nearest (const point_basic< T > &x, point_basic< T > &x_nearest) const =0
virtual size_type | dis_nearest (const point_basic< T > &x, point_basic< T > &x_nearest) const =0
virtual odiststream & | put (odiststream &ops) const =0
virtual bool | check (bool verbose) const =0
bool | operator== (const geo_abstract_base_rep< T > &omega2) const

## Detailed Description

### template<class T>
class rheolef::geo_abstract_base_rep< T >

abstract base interface class

Definition at line 248 of file geo.h.

## Member Typedef Documentation

## size_type

typedef geo_element_hack::size_type size_type

Definition at line 260 of file geo.h.

## node_type

typedef point_basic<T> node_type

Definition at line 261 of file geo.h.

## variant_type

typedef reference_element::variant_type variant_type

Definition at line 262 of file geo.h.

## reference

typedef geo_element& reference

Definition at line 263 of file geo.h.

## const_reference

typedef const geo_element& const_reference

Definition at line 264 of file geo.h.

## coordinate_type

typedef space_constant::coordinate_type coordinate_type

Definition at line 265 of file geo.h.

## geo_element_map_type

typedef std::map<size_type,geo_element_auto<> > geo_element_map_type

Definition at line 266 of file geo.h.

## iterator_by_variant

typedef hack_array<geo_element_hack>::iterator iterator_by_variant

Definition at line 269 of file geo.h.

## iterator

typedef geo_iterator< geo_element, geo_element&, geo_element*, iterator_by_variant> iterator

Definition at line 275 of file geo.h.

## const_iterator_by_variant

typedef hack_array<geo_element_hack>::const_iterator const_iterator_by_variant

Definition at line 278 of file geo.h.

## const_iterator

typedef geo_iterator< geo_element, const geo_element&, const geo_element*, const_iterator_by_variant> const_iterator

Definition at line 284 of file geo.h.

## Member Enumeration Documentation

## geo_rep_variant_type

enum geo_rep_variant_type

Enumerator
geo |
geo_domain |
geo_domain_indirect |
max_variant |

Definition at line 253 of file geo.h.

## Constructor & Destructor Documentation

## geo_abstract_base_rep()

geo_abstract_base_rep | ( |  | ) |

Definition at line 288 of file geo.h.

## ~geo_abstract_base_rep()

virtual ~geo_abstract_base_rep | ( |  | ) |

virtual

Definition at line 289 of file geo.h.

## Member Function Documentation

## variant()

virtual size_type variant | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## name()

virtual std::string name | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## familyname()

virtual std::string familyname | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## dimension()

virtual size_type dimension | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## serial_number()

virtual size_type serial_number | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## map_dimension()

virtual size_type map_dimension | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_rep< T, distributed >, geo_rep< T, sequential >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## is_broken()

virtual bool is_broken | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_rep< T, distributed >, geo_rep< T, sequential >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## coordinate_system()

virtual coordinate_type coordinate_system | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## get_piola_basis()

virtual const basis_basic<T>& get_piola_basis | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## xmin()

virtual const node_type& xmin | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## xmax()

virtual const node_type& xmax | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## hmin()

virtual const T& hmin | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## hmax()

virtual const T& hmax | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## sizes()

virtual const geo_size& sizes | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## ios_sizes()

virtual const geo_size& ios_sizes | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## geo_element_ownership()

virtual const distributor& geo_element_ownership | ( | size_type | dim | ) | const

pure virtual

Implemented in geo_rep< T, distributed >, geo_rep< T, sequential >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## get_geo_element()

virtual const_reference get_geo_element | ( | size_type | dim,
|  | size_type | ige
| ) |  | const

pure virtual

Implemented in geo_rep< T, distributed >, and geo_rep< T, sequential >.

## bgd2dom_geo_element()

virtual const geo_element& bgd2dom_geo_element | ( | const geo_element & | bgd_K | ) | const

virtual

Definition at line 311 of file geo.h.

## dom2bgd_geo_element()

virtual const geo_element& dom2bgd_geo_element | ( | const geo_element & | dom_K | ) | const

virtual

Definition at line 312 of file geo.h.

## neighbour()

virtual size_type neighbour | ( | size_type | ie,
|  | size_type | loc_isid
| ) |  | const

pure virtual

## neighbour_guard()

virtual void neighbour_guard | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## begin_by_variant()

virtual const_iterator_by_variant begin_by_variant | ( | variant_type | variant | ) | const

pure virtual

## end_by_variant()

virtual const_iterator_by_variant end_by_variant | ( | variant_type | variant | ) | const

pure virtual

## get_external_geo_element_map()

virtual const geo_element_map_type& get_external_geo_element_map | ( | size_type | variant | ) | const

pure virtual

Implemented in geo_rep< T, distributed >, and geo_rep< T, sequential >.

## begin()

geo_abstract_base_rep< T >::const_iterator begin | ( | size_type | dim | ) | const

Definition at line 760 of file geo.h.

## end()

geo_abstract_base_rep< T >::const_iterator end | ( | size_type | dim | ) | const

Definition at line 769 of file geo.h.

## n_node()

virtual size_type n_node | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## node()

virtual const node_type& node | ( | size_type | inod | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## dis_node()

virtual const node_type& dis_node | ( | size_type | dis_inod | ) | const

pure virtual

Implemented in geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## dis_inod()

virtual void dis_inod | ( | const geo_element & | K,
|  | std::vector< size_type > & | dis_inod
| ) |  | const

pure virtual

## dis_inod2dis_iv()

virtual size_type dis_inod2dis_iv | ( | size_type | dis_inod | ) | const

pure virtual

## n_domain_indirect()

virtual size_type n_domain_indirect | ( |  | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## have_domain_indirect()

virtual bool have_domain_indirect | ( | const std::string & | name | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## reset_order()

virtual void reset_order | ( | size_type | order | ) |

pure virtual

Implemented in geo_rep< T, distributed >, and geo_rep< T, sequential >.

## seq_locate()

virtual size_type seq_locate | ( | const point_basic< T > & | x,
|  | size_type | dis_ie_guest = `std::numeric_limits< size_type >::max()`
| ) |  | const

pure virtual

## dis_locate()

virtual size_type dis_locate | ( | const point_basic< T > & | x,
|  | size_type | dis_ie_guest = `std::numeric_limits< size_type >::max()`
| ) |  | const

pure virtual

## seq_trace_move()

virtual size_type seq_trace_move | ( | const point_basic< T > & | x,
|  | const point_basic< T > & | v,
|  | point_basic< T > & | y
| ) |  | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## dis_trace_move()

virtual size_type dis_trace_move | ( | const point_basic< T > & | x,
|  | const point_basic< T > & | v,
|  | point_basic< T > & | y
| ) |  | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## seq_nearest()

virtual size_type seq_nearest | ( | const point_basic< T > & | x,
|  | point_basic< T > & | x_nearest
| ) |  | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## dis_nearest()

virtual size_type dis_nearest | ( | const point_basic< T > & | x,
|  | point_basic< T > & | x_nearest
| ) |  | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_base_rep< T, sequential >, and geo_base_rep< T, distributed >.

## put()

virtual odiststream& put | ( | odiststream & | ops | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_rep< T, sequential >, and geo_rep< T, distributed >.

## check()

virtual bool check | ( | bool | verbose | ) | const

pure virtual

Implemented in geo_domain_indirect_base_rep< T, sequential >, geo_domain_indirect_base_rep< T, distributed >, geo_rep< T, distributed >, and geo_rep< T, sequential >.

## operator==()

bool operator== | ( | const geo_abstract_base_rep< T > & | omega2 | ) | const

Definition at line 363 of file geo.h.

The documentation for this class was generated from the following file:

- /build/rheolef-FQTnje/rheolef-7.1/main/lib/geo.h